"""
Django settings for billetterie project.

Generated by 'django-admin startproject' using Django 1.11.6.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""
import datetime
import os
import sys

import dj_database_url

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('SECRET_KEY', '^&2upg8b26db6l#3o&2jsfta2@mkek^pan^a-h29v1gi&l%57!')
SECURE_PROXY_SSL_HEADER = ('HTTP_X_FORWARDED_PROTO', 'https')
USE_X_FORWARDED_HOST = True

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get('DEBUG', 'False') == 'true'

LOG_LEVEL = os.environ.get('LOG_LEVEL', 'DEBUG' if DEBUG else 'INFO')

ALLOWED_HOSTS = os.environ.get('HOST', 'localhost').split(',') + ["3da0-134-214-58-112.ngrok.io"]
CORS_ORIGIN_WHITELIST = [
                            'https://billetterie.bde-insa-lyon.fr',
                            'https://billetterie.asso-insa-lyon.fr',
                            'http://localhost:4200',
                            'http://127.0.0.1:4200',
                            'http://localhost:4201',
                            'http://127.0.0.1:4201',
                            'http://127.0.0.1:8000',
                            'http://0.0.0.0:8000',
                            'http://localhost:8000',
                            'http://10.100.1.124',
                            'https://api-billetterie.test.bde-insa-lyon.fr'
                        ] + os.environ.get('DOMAINS', 'http://127.0.0.1:8000').split(',')

CORS_ALLOW_CREDENTIALS = True

CSRF_TRUSTED_ORIGINS = [
                           'billetterie.bde-insa-lyon.fr',
                           'localhost:4200',
                           '127.0.0.1:4200',
                           'localhost:4201',
                           '127.0.0.1:4201',
                           '10.100.1.123',
                           '10.100.1.124',
                           'reader.billetterie.bde-insa-lyon.fr'  # addresse du serveur Angular
                           'billetterie.test.bde-insa-lyon.fr'
                       ] + os.environ.get('DOMAINS', '').split(',')

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'anymail',
    'rest_framework',
    'rest_framework_swagger',
    'corsheaders',
    'api.apps.ApiConfig',
    'mercanet',
    'orga',
    'import_export',
    'permanencier',
    'crispy_forms',
    'django_crontab',
    'prdd'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'corsheaders.middleware.CorsPostCsrfMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'permanencier.error_handler.HandlePermanencierExceptionMiddleware',
]

ROOT_URLCONF = 'billetterie.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')]
        ,
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'billetterie.wsgi.application'

REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': (
        'api.permissions.IsAuthenticatedAndReadOnly',
        'rest_framework.permissions.AllowAny',
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
        'rest_framework.authentication.SessionAuthentication',
        'rest_framework.authentication.BasicAuthentication',
    ),
}

JWT_AUTH = {
    'JWT_ALLOW_REFRESH': True,
    'JWT_EXPIRATION_DELTA': datetime.timedelta(days=7),
    'JWT_REFRESH_EXPIRATION_DELTA': datetime.timedelta(days=7)
}

# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {
    'default': dj_database_url.config(default='sqlite:///' + os.path.join(BASE_DIR, 'db.sqlite3'), conn_max_age=600)
}

# EMAIL_FILE_PATH = '/tmp/app-messages'
if os.environ.get('EMAIL_CONSOLE', 'False') == 'True':
    sys.stderr.write("using console backend\n")
    EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'
else:
    EMAIL_BACKEND = "anymail.backends.mailjet.EmailBackend"
    sys.stderr.write("Using Anymail\n")
ANYMAIL = {
    "MAILJET_API_KEY": os.getenv('MAILJET_API_KEY'),
    "MAILJET_SECRET_KEY": os.getenv('MAILJET_SECRET_KEY'),
}
DEFAULT_FROM_EMAIL = os.environ.get('DEFAULT_FROM_EMAIL', 'billetterie@email.bde-insa-lyon.fr')
# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    #  No conditions on password for development phase
    # {
    #     'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    # },
    # {
    #     'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    # },
    # {
    #     'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    # },
    # {
    #     'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    # },
]

# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'fr-fr'

TIME_ZONE = 'Europe/Paris'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATIC_URL = '/static/'
MEDIA_URL = '/uploads/'
STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")
MEDIA_ROOT = os.path.join(BASE_DIR, "uploads")

STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static")
]

BILLEVENT = {
    'FRONTEND_URL': os.environ.get('FRONTEND_URL', 'http://localhost:4200'),
    'API_URL': os.environ.get('API_URL', 'http://localhost:8000'),
    'MERCANET': {
        'INTERFACE_VERSION': os.environ.get('MERCANET_INTERFACE_VERSION', 'IR_WS_2.18'),
        'KEY_VERSION': os.environ.get('MERCANET_KEY_VERSION', '1'),
        'MERCHANT_ID': os.environ.get('MERCANET_MERCHANT_ID', '211000021310001'),
        'URL': os.environ.get('MERCANET_URL',
                              'https://payment-webinit-mercanet.test.sips-services.com/rs-services/v2/paymentInit'),
        'SECRET_KEY': os.environ.get('MERCANET_SECRET_KEY', 'S9i8qClCnb2CZU3y3Vn0toIOgz3z_aBi79akR30vM9o'),
        'REPONSE_AUTO_URL': os.environ.get('MERCANET_REPONSE_AUTO_URL',
                                           'https://billetterie-mercanet.ultrahook.com/pay/auto/'),
    }
}

ADHESION = {
    'ADHESION_URL': os.environ.get('ADHESION_URL', "https://api-adhesion.asso-insa-lyon.fr"),
    'KEYCLOAK_ENDPOINT': os.environ.get('KEYCLOAK_URL', 'https://sso.asso-insa-lyon.fr/auth/realms/asso-insa-lyon/protocol/openid-connect/token'),
    'CLIENT_ID': os.environ.get('ADHESION_CLIENT_ID', "<client_id_placeholder>"),
    'CLIENT_SECRET': os.environ.get('ADHESION_CLIENT_SECRET',
                                    "<client_secret_placeholder>")
}

CRISPY_TEMPLATE_PACK = 'bootstrap4'

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
        },
        # 'mail_admins_debug': {
        #    'level': 'ERROR',
        #    'class': 'django.utils.log.AdminEmailHandler',
        #    'include_html': True,
        # }
    },
    'loggers': {
        'adhesion_api': {
            'handlers': ['console'],
            'level': LOG_LEVEL,
        },
        'mercanet': {
            'handlers': ['console'],
            'level': LOG_LEVEL,
        },
        'permanencier': {
            'handlers': ['console'],
            'level': LOG_LEVEL
        }
    },
}
CRONJOBS = [
    (os.getenv('CLEAN_ORDERS_CRON', '5 * * * *'), 'api.cron.clean_old_orders')
]
